#

API Docs for: v2.11.1
Show: Inherited Protected Private Deprecated

# Ember.Array Class

Uses

- Ember.Enumerable

Defined in: `packages/ember-runtime/lib/mixins/array.js:167`
Module: ember-runtime
Parent Module: ember

Available since Ember 0.9.0

This mixin implements Observer-friendly Array-like behavior. It is not a concrete implementation, but it can be used up by other classes that want to appear like arrays.

For example, ArrayProxy is a concrete classes that can be instantiated to implement array-like behavior. Both of these classes use the Array Mixin by way of the MutableArray mixin, which allows observable changes to be made to the underlying array.

Unlike `Ember.Enumerable,` this mixin defines methods specifically for collections that provide index-ordered access to their contents. When you are designing code that needs to accept any kind of Array-like object, you should use these methods instead of Array primitives because these will properly notify observers of changes to the array.

Although these methods are efficient, they do add a layer of indirection to your application so it is a good idea to use them only when you need the flexibility of using both true JavaScript arrays and "virtual" arrays such as controllers and collections.

You can use the methods defined in this module to access and modify array contents in a KVO-friendly way. You can also be notified whenever the membership of an array changes by using `.observes('myArray.[]')`.

To support `Ember.Array` in your own class, you must override two primitives to use it: `length()` and `objectAt()`.

Note that the Ember.Array mixin also incorporates the `Ember.Enumerable` mixin. All `Ember.Array`-like objects are also enumerable.

- Index
- Methods
- Properties

## Item Index

### Methods

- addArrayObserver
- addEnumerableObserver
- any
- arrayContentDidChange
- arrayContentWillChange
- compact
- contains deprecated
- enumerableContentDidChange
- enumerableContentWillChange
- every
- filter
- filterBy
- find
- findBy
- forEach
- getEach
- includes
- indexOf
- invoke
- isAny
- isEvery
- lastIndexOf
- map
- mapBy
- nextObject
- objectAt
- objectsAt
- reduce
- reject
- rejectBy
- removeArrayObserver
- removeEnumerableObserver
- setEach
- slice
- sortBy
- toArray
- uniq
- uniqBy
- without

### Properties

- @each
- []
- firstObject
- hasArrayObservers
- hasEnumerableObservers
- lastObject
- length

## Methods

### `addArrayObserver`

(

- `target`
- `opts`

)
Ember.Array public

Defined in `packages/ember-runtime/lib/mixins/array.js:454`

Adds an array observer to the receiving array. The array observer object normally must implement two methods:

- `arrayWillChange(observedObj, start, removeCount, addCount)` - This method will be called just before the array is modified.
- `arrayDidChange(observedObj, start, removeCount, addCount)` - This method will be called just after the array is modified.

Both callbacks will be passed the observed object, starting index of the change as well as a count of the items to be removed and added. You can use these callbacks to optionally inspect the array during the change, clear caches, or do any other bookkeeping necessary.

In addition to passing a target, you can also include an options hash which you can use to override the method names that will be invoked on the target.

#### Parameters:

- `target` Object

  The observer object.

- `opts` Object

  Optional hash of configuration options including `willChange` and `didChange` option.

#### Returns:

Ember.Array:

receiver

### `addEnumerableObserver`

(

- `target`
- `[opts]`

)
private

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:866`

Registers an enumerable observer. Must implement `Ember.EnumerableObserver` mixin.

#### Parameters:

- `target` Object
- `[opts]` Object optional

#### Returns:

this

### `any`

(

- `callback`
- `[target]`

)
Boolean public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:608`

Returns `true` if the passed function returns true for any item in the enumeration. This corresponds with the `some()` method in JavaScript 1.6. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. It should return the `true` to include the item in the results, `false` otherwise. Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object. Usage Example: ```javascript if (people.any(isManager)) { Paychecks.addBiggerBonus(); } ```

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Boolean: `true` if the passed function returns `true` for any item

### `arrayContentDidChange`

(

- `startIdx`
- `removeAmt`
- `addAmt`

)
Ember.Array public

Defined in `packages/ember-runtime/lib/mixins/array.js:530`

If you are implementing an object that supports `Ember.Array`, call this method just after the array content changes to notify any observers and invalidate any related properties. Pass the starting index of the change as well as a delta of the amounts to change.

#### Parameters:

- `startIdx` Number

  The starting index in the array that did change.

- `removeAmt` Number

  The number of items that were removed. If you pass `null` assumes 0

- `addAmt` Number

  The number of items that were added. If you pass `null` assumes 0.

#### Returns:

Ember.Array:

receiver

### `arrayContentWillChange`

(

- `startIdx`
- `removeAmt`
- `addAmt`

)
Ember.Array public

Defined in `packages/ember-runtime/lib/mixins/array.js:511`

If you are implementing an object that supports `Ember.Array`, call this method just before the array content changes to notify any observers and invalidate any related properties. Pass the starting index of the change as well as a delta of the amounts to change.

#### Parameters:

- `startIdx` Number

  The starting index in the array that will change.

- `removeAmt` Number

  The number of items that will be removed. If you pass `null` assumes 0

- `addAmt` Number

  The number of items that will be added. If you pass `null` assumes 0.

#### Returns:

Ember.Array:

receiver

### `compact`

() Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:771`

Returns a copy of the array with all `null` and `undefined` elements removed. ```javascript let arr = ['a', null, 'c', undefined]; arr.compact(); // ['a', 'c'] ```

#### Returns:

Array: the array without null and undefined elements.

### `contains`

(

- `obj`

)
Boolean deprecated public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:213`

Deprecated: Use `Enumerable#includes` instead. See http://emberjs.com/deprecations/v2.x#toc_enumerable-contains

Returns `true` if the passed object can be found in the receiver. The default version will iterate through the enumerable until the object is found. You may want to override this with a more efficient version. ```javascript let arr = ['a', 'b', 'c']; arr.contains('a'); // true arr.contains('z'); // false ```

#### Parameters:

- `obj` Object
  The object to search for.

#### Returns:

Boolean: `true` if object is found in enumerable.

### `enumerableContentDidChange`

(

- `removing`
- `adding`

)
private chainable

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:989`

Invoke this method when the contents of your enumerable has changed. This will notify any observers watching for content changes. If you are implementing an ordered enumerable (such as an array), also pass the start and end values where the content changed so that it can be used to notify range observers.

#### Parameters:

- `removing` Ember.Enumerable | Number
  An enumerable of the objects to be removed or the number of items to be removed.
- `adding` Ember.Enumerable | Number
  An enumerable of the objects to be added or the number of items to be added.

### `enumerableContentWillChange`

(

- `removing`
- `adding`

)
private chainable

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:936`

Invoke this method just before the contents of your enumerable will change. You can either omit the parameters completely or pass the objects to be removed or added if available or just a count.

#### Parameters:

- `removing` Ember.Enumerable | Number
  An enumerable of the objects to be removed or the number of items to be removed.
- `adding` Ember.Enumerable | Number
  An enumerable of the objects to be added or the number of items to be added.

### `every`

(

- `callback`
- `[target]`

)
Boolean public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:553`

Returns `true` if the passed function returns true for every item in the enumeration. This corresponds with the `every()` method in JavaScript 1.6. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. It should return the `true` or `false`. Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object. Example Usage: ```javascript if (people.every(isEngineer)) { Paychecks.addBigBonus(); } ```

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Boolean:

### `filter`

(

- `callback`
- `[target]`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:370`

Returns an array with all of the items in the enumeration that the passed function returns true for. This method corresponds to `filter()` defined in JavaScript 1.6. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. It should return `true` to include the item in the results, `false` otherwise. Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Array: A filtered array.

### `filterBy`

(

- `key`
- `[value]`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:444`

Returns an array with just the items with the matched property. You can pass an optional second argument with the target value. Otherwise this will match any property that evaluates to `true`.

#### Parameters:

- `key` String
  the property to test
- `[value]` optional
  optional value to test against.

#### Returns:

Array: filtered array

### `find`

(

- `callback`
- `[target]`

)
Object public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:478`

Returns the first item in the array for which the callback returns true. This method works similar to the `filter()` method defined in JavaScript 1.6 except that it will stop working on the array once a match is found. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. It should return the `true` to include the item in the results, `false` otherwise. Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Object: Found item or `undefined`.

### `findBy`

(

- `key`
- `[value]`

)
Object public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:536`

Returns the first item with a property matching the passed value. You can pass an optional second argument with the target value. Otherwise this will match any property that evaluates to `true`. This method works much like the more generic `find()` method.

#### Parameters:

- `key` String
  the property to test
- `[value]` String optional
  optional value to test against.

#### Returns:

Object: found item or `undefined`

### `forEach`

(

- `callback`
- `[target]`

)
Object public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:245`

Iterates through the enumerable, calling the passed function on each item. This method corresponds to the `forEach()` method defined in JavaScript 1.6. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Object: receiver

### `getEach`

(

- `key`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:296`

Alias for `mapBy`

#### Parameters:

- `key` String
  name of the property

#### Returns:

Array: The mapped array.

### `includes`

(

- `obj`
- `startAt`

)
Boolean public

Inherited from Ember.Enumerable but overwritten in `packages/ember-runtime/lib/mixins/array.js:587`

Returns `true` if the passed object can be found in the array. This method is a Polyfill for ES 2016 Array.includes. If no `startAt` argument is given, the starting location to search is 0. If it's negative, searches from the index of `this.length + startAt` by asc.

    [1, 2, 3].includes(2);     // true
    [1, 2, 3].includes(4);     // false
    [1, 2, 3].includes(3, 2);  // true
    [1, 2, 3].includes(3, 3);  // false
    [1, 2, 3].includes(3, -1); // true
    [1, 2, 3].includes(1, -1); // false
    [1, 2, 3].includes(1, -4); // true
    [1, 2, NaN].includes(NaN); // true

#### Parameters:

- `obj` Object

  The object to search for.

- `startAt` Number

  optional starting location to search, default 0

#### Returns:

Boolean:

`true` if object is found in the array.

### `indexOf`

(

- `object`
- `startAt`

)
Number public

Defined in `packages/ember-runtime/lib/mixins/array.js:364`

Returns the index of the given object's first occurrence. If no `startAt` argument is given, the starting location to search is 0. If it's negative, will count backward from the end of the array. Returns -1 if no match is found.

    let arr = ['a', 'b', 'c', 'd', 'a'];

    arr.indexOf('a');       //  0
    arr.indexOf('z');       // -1
    arr.indexOf('a', 2);    //  4
    arr.indexOf('a', -1);   //  4
    arr.indexOf('b', 3);    // -1
    arr.indexOf('a', 100);  // -1

#### Parameters:

- `object` Object

  the item to search for

- `startAt` Number

  optional starting location to search, default 0

#### Returns:

Number:

index or -1 if not found

### `invoke`

(

- `methodName`
- `args`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:730`

Invokes the named method on every object in the receiver that implements it. This method corresponds to the implementation in Prototype 1.6.

#### Parameters:

- `methodName` String
  the name of the method
- `args` Object...
  optional arguments to pass as well.

#### Returns:

Array: return values from calling invoke.

### `isAny`

(

- `key`
- `[value]`

)
Boolean public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:666`

Available since 1.3.0

Returns `true` if the passed property resolves to the value of the second argument for any item in the enumerable. This method is often simpler/faster than using a callback.

#### Parameters:

- `key` String
  the property to test
- `[value]` String optional
  optional value to test against. Defaults to `true`

#### Returns:

Boolean:

### `isEvery`

(

- `key`
- `[value]`

)
Boolean public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:592`

Available since 1.3.0

Returns `true` if the passed property resolves to the value of the second argument for all items in the enumerable. This method is often simpler/faster than using a callback.

#### Parameters:

- `key` String
  the property to test
- `[value]` String optional
  optional value to test against. Defaults to `true`

#### Returns:

Boolean:

### `lastIndexOf`

(

- `object`
- `startAt`

)
Number public

Defined in `packages/ember-runtime/lib/mixins/array.js:407`

Returns the index of the given object's last occurrence. If no `startAt` argument is given, the search starts from the last position. If it's negative, will count backward from the end of the array. Returns -1 if no match is found.

    let arr = ['a', 'b', 'c', 'd', 'a'];

    arr.lastIndexOf('a');       //  4
    arr.lastIndexOf('z');       // -1
    arr.lastIndexOf('a', 2);    //  0
    arr.lastIndexOf('a', -1);   //  4
    arr.lastIndexOf('b', 3);    //  1
    arr.lastIndexOf('a', 100);  //  4

#### Parameters:

- `object` Object

  the item to search for

- `startAt` Number

  optional starting location to search, default 0

#### Returns:

Number:

index or -1 if not found

### `map`

(

- `callback`
- `[target]`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:322`

Maps all of the items in the enumeration to another value, returning a new array. This method corresponds to `map()` defined in JavaScript 1.6. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. It should return the mapped value. Note that in addition to a callback, you can also pass an optional target object that will be set as `this` on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Array: The mapped array.

### `mapBy`

(

- `key`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:357`

Similar to map, this specialized function returns the value of the named property on all items in the enumeration.

#### Parameters:

- `key` String
  name of the property

#### Returns:

Array: The mapped array.

### `nextObject`

(

- `index`
- `previousObject`
- `context`

)
Object private

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:98`

__Required.__ You must implement this method to apply this mixin. Implement this method to make your class enumerable. This method will be called repeatedly during enumeration. The index value will always begin with 0 and increment monotonically. You don't have to rely on the index value to determine what object to return, but you should always check the value and start from the beginning when you see the requested index is 0. The `previousObject` is the object that was returned from the last call to `nextObject` for the current iteration. This is a useful way to manage iteration if you are tracing a linked list, for example. Finally the context parameter will always contain a hash you can use as a "scratchpad" to maintain any other state you need in order to iterate properly. The context object is reused and is not reset between iterations so make sure you setup the context with a fresh state whenever the index parameter is 0. Generally iterators will continue to call `nextObject` until the index reaches the current length-1. If you run out of data before this time for some reason, you should simply return undefined. The default implementation of this method simply looks up the index. This works great on any Array-like objects.

#### Parameters:

- `index` Number
  the current index of the iteration
- `previousObject` Object
  the value returned by the last call to `nextObject`.
- `context` Object
  a context object you can use to maintain state.

#### Returns:

Object: the next object in the iteration or undefined

### `objectAt`

(

- `idx`

)
public

Defined in `packages/ember-runtime/lib/mixins/array.js:219`

Returns the object at the given `index`. If the given `index` is negative or is greater or equal than the array length, returns `undefined`.

This is one of the primitives you must implement to support `Ember.Array`. If your object supports retrieving the value of an array item using `get()` (i.e. `myArray.get(0)`), then you do not need to implement this method yourself.

    let arr = ['a', 'b', 'c', 'd'];

    arr.objectAt(0);   // 'a'
    arr.objectAt(3);   // 'd'
    arr.objectAt(-1);  // undefined
    arr.objectAt(4);   // undefined
    arr.objectAt(5);   // undefined

#### Parameters:

- `idx` Number

  The index of the item to return.

#### Returns:

:

item at index or undefined

### `objectsAt`

(

- `indexes`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/array.js:251`

This returns the objects at the specified indexes, using `objectAt`.

    let arr = ['a', 'b', 'c', 'd'];

    arr.objectsAt([0, 1, 2]);  // ['a', 'b', 'c']
    arr.objectsAt([2, 3, 4]);  // ['c', 'd', undefined]

#### Parameters:

- `indexes` Array

  An array of indexes of items to return.

#### Returns:

Array:

### `reduce`

(

- `callback`
- `initialValue`
- `reducerProperty`

)
Object public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:682`

This will combine the values of the enumerator into a single value. It is a useful way to collect a summary value from an enumeration. This corresponds to the `reduce()` method defined in JavaScript 1.8. The callback method you provide should have the following signature (all parameters are optional): ```javascript function(previousValue, item, index, enumerable); ``` - `previousValue` is the value returned by the last call to the iterator. - `item` is the current item in the iteration. - `index` is the current index in the iteration. - `enumerable` is the enumerable object itself. Return the new cumulative value. In addition to the callback you can also pass an `initialValue`. An error will be raised if you do not pass an initial value and the enumerator is empty. Note that unlike the other methods, this method does not allow you to pass a target object to set as this for the callback. It's part of the spec. Sorry.

#### Parameters:

- `callback` Function
  The callback to execute
- `initialValue` Object
  Initial value for the reduce
- `reducerProperty` String
  internal use only.

#### Returns:

Object: The reduced value.

### `reject`

(

- `callback`
- `[target]`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:411`

Returns an array with all of the items in the enumeration where the passed function returns false. This method is the inverse of filter(). The callback method you provide should have the following signature (all parameters are optional): ```javascript function(item, index, enumerable); ``` - *item* is the current item in the iteration. - *index* is the current index in the iteration - *enumerable* is the enumerable object itself. It should return a falsey value to include the item in the results. Note that in addition to a callback, you can also pass an optional target object that will be set as "this" on the context. This is a good way to give your iterator function access to the current object.

#### Parameters:

- `callback` Function
  The callback to execute
- `[target]` Object optional
  The target object to use

#### Returns:

Array: A rejected array.

### `rejectBy`

(

- `key`
- `[value]`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:459`

Returns an array with the items that do not have truthy values for key. You can pass an optional second argument with the target value. Otherwise this will match any property that evaluates to false.

#### Parameters:

- `key` String
  the property to test
- `[value]` String optional
  optional value to test against.

#### Returns:

Array: rejected array

### `removeArrayObserver`

(

- `target`
- `opts`

)
Ember.Array public

Defined in `packages/ember-runtime/lib/mixins/array.js:484`

Removes an array observer from the object if the observer is current registered. Calling this method multiple times with the same object will have no effect.

#### Parameters:

- `target` Object

  The object observing the array.

- `opts` Object

  Optional hash of configuration options including `willChange` and `didChange` option.

#### Returns:

Ember.Array:

receiver

### `removeEnumerableObserver`

(

- `target`
- `[opts]`

)
private

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:895`

Removes a registered enumerable observer.

#### Parameters:

- `target` Object
- `[opts]` Object optional

#### Returns:

this

### `setEach`

(

- `key`
- `value`

)
Object public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:306`

Sets the value on the named property for each member. This is more ergonomic than using other methods defined on this helper. If the object implements Ember.Observable, the value will be changed to `set(),` otherwise it will be set directly. `null` objects are skipped.

#### Parameters:

- `key` String
  The key to set
- `value` Object
  The object to set

#### Returns:

Object: receiver

### `slice`

(

- `beginIndex`
- `endIndex`

)
Array public

Defined in `packages/ember-runtime/lib/mixins/array.js:318`

Returns a new array that is a slice of the receiver. This implementation uses the observable array methods to retrieve the objects for the new slice.

    let arr = ['red', 'green', 'blue'];

    arr.slice(0);       // ['red', 'green', 'blue']
    arr.slice(0, 2);    // ['red', 'green']
    arr.slice(1, 100);  // ['green', 'blue']

#### Parameters:

- `beginIndex` Number

  (Optional) index to begin slicing from.

- `endIndex` Number

  (Optional) index to end the slice at (but not included).

#### Returns:

Array:

New array with specified slice

### `sortBy`

(

- `property`

)
Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:1044`

Available since 1.2.0

Converts the enumerable into an array and sorts by the keys specified in the argument. You may provide multiple arguments to sort by multiple properties.

#### Parameters:

- `property` String
  name(s) to sort on

#### Returns:

Array: The sorted array.

### `toArray`

() Array public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:755`

Simply converts the enumerable into a genuine array. The order is not guaranteed. Corresponds to the method implemented by Prototype.

#### Returns:

Array: the enumerable as an array.

### `uniq`

() Ember.Enumerable public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:818`

Returns a new enumerable that contains only unique values. The default implementation returns an array regardless of the receiver type. ```javascript let arr = ['a', 'a', 'b', 'b']; arr.uniq(); // ['a', 'b'] ``` This only works on primitive data types, e.g. Strings, Numbers, etc.

#### Returns:

Ember.Enumerable:

### `uniqBy`

() Ember.Enumerable public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:1079`

Returns a new enumerable that contains only items containing a unique property value. The default implementation returns an array regardless of the receiver type. ```javascript let arr = [{ value: 'a' }, { value: 'a' }, { value: 'b' }, { value: 'b' }]; arr.uniqBy('value'); // [{ value: 'a' }, { value: 'b' }] ```

#### Returns:

Ember.Enumerable:

### `without`

(

- `value`

)
Ember.Enumerable public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:787`

Returns a new enumerable that excludes the passed value. The default implementation returns an array regardless of the receiver type. If the receiver does not contain the value it returns the original enumerable. ```javascript let arr = ['a', 'b', 'a', 'c']; arr.without('a'); // ['b', 'c'] ```

#### Parameters:

- `value` Object

#### Returns:

Ember.Enumerable:

## Properties

### `@each`

Unknown public

Defined in `packages/ember-runtime/lib/mixins/array.js:549`

Returns a special object that can be used to observe individual properties on the array. Just get an equivalent property on this object and it will return an enumerable that maps automatically to the named key on the member objects.

`@each` should only be used in a non-terminal context. Example:

    myMethod: computed('posts.@each.author', function(){
      ...
    });

If you merely want to watch for the array being changed, like an object being replaced, added or removed, use `[]` instead of `@each`.

    myMethod: computed('posts.[]', function(){
      ...
    });

### `[]`

Unknown public

Inherited from Ember.Enumerable but overwritten in `packages/ember-runtime/lib/mixins/array.js:275`

This is the handler for the special array content property. If you get this property, it will return this. If you set this property to a new array, it will replace the current content.

This property overrides the default property defined in `Ember.Enumerable`.

### `firstObject`

Unknown public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:136`

Helper method returns the first object from a collection. This is usually used by bindings and other parts of the framework to extract a single object if the enumerable contains only one item. If you override this method, you should implement it so that it will always return the same value each time it is called. If your enumerable contains only one object, this method should always return that object. If your enumerable is empty, this method should return `undefined`. ```javascript let arr = ['a', 'b', 'c']; arr.get('firstObject'); // 'a' let arr = []; arr.get('firstObject'); // undefined ```

### `hasArrayObservers`

Boolean public

Defined in `packages/ember-runtime/lib/mixins/array.js:500`

Becomes true whenever the array currently has observers watching changes on the array.

### `hasEnumerableObservers`

Boolean private

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:923`

Becomes true whenever the array currently has observers watching changes on the array.

### `lastObject`

Unknown public

Inherited from Ember.Enumerable: `packages/ember-runtime/lib/mixins/enumerable.js:173`

Helper method returns the last object from a collection. If your enumerable contains only one object, this method should always return that object. If your enumerable is empty, this method should return `undefined`. ```javascript let arr = ['a', 'b', 'c']; arr.get('lastObject'); // 'c' let arr = []; arr.get('lastObject'); // undefined ```

### `length`

Number public

Defined in `packages/ember-runtime/lib/mixins/array.js:208`

Required. You must implement this method to apply this mixin.

Your array must support the `length` property. Your replace methods should set this property whenever it changes.